from .misc import connection_from_s_or_c
from .inspector import NullInspector
from .pg import PostgreSQL

SUPPORTED = {"postgresql": PostgreSQL}


def get_inspector(x, schema=None):
    if x is None:
        return NullInspector()

    c = connection_from_s_or_c(x)
    try:
        ic = SUPPORTED[c.dialect.name]
    except KeyError:
        raise NotImplementedError

    inspected = ic(c)
    if schema:
        inspected.one_schema(schema)
    return inspected
